#ifndef MATHTABLE_H
#define MATHTABLE_H

/* function type */
typedef enum {
    ADD,
    SUB,
    MULT,
    SLOPE,
    MAX_FUNC_ID /* to ease boundary checking */
} mathfunctype_t; 

/* generic argument type */
typedef struct {
    int argc;   /* we will choose arguments according to this value */
    union {
        int arg2[2];
        int arg4[4];
    } arg;
} matharg_t;

extern int math_call(mathfunctype_t,const matharg_t *arg,int *res);

#endif  /* MATHTABLE_H */
